/* Copyright (C) 2009 Pierre Nicolas
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "fbvar.h"

#include<iostream>
#include<vector>
#include<cmath>
#include<gsl/gsl_randist.h>
#include<gsl/gsl_cdf.h>

FbVar::FbVar(Params& par, int windowl)
{
  _windowl = windowl;
  _nS=par._nS;
  _nR=par._nR;

  
  _pobs_gaussian = new float* [_windowl];
  for (int t=0; t<_windowl; t++) {
    _pobs_gaussian[t] = new float [_nS];
  }
  _pforw1 = new float** [_windowl];
  _pforw2 = new float** [_windowl];
  _pforw3 = new float** [_windowl];
  _pforw4 = new float** [_windowl];
  _pback1 = new float** [_windowl];
  _pback2 = new float** [_windowl];

  _vitVval = new float** [_windowl];
  _vitVbackM = new int** [_windowl];
  _vitVbackS = new int** [_windowl];
  _vitWval = new float** [_windowl];
  _vitWbackR = new int** [_windowl];

  
  for (int t=0; t<_windowl; t++) {
    _pforw1[t] = new float* [_nR];
    _pforw2[t] = new float* [_nR];
    _pforw3[t] = new float* [_nR];
    _pforw4[t] = new float* [_nR];
    _pback1[t] = new float* [_nR];
    _pback2[t] = new float* [_nR];

    _vitVval[t] = new float* [_nR];
    _vitVbackM[t] = new int* [_nR];
    _vitVbackS[t] = new int* [_nR];
    _vitWval[t] = new float* [_nR];
    _vitWbackR[t] = new int* [_nR];

    for (int p=0; p<_nR; p++) {
      _pforw1[t][p] = new float [_nS];
      _pforw2[t][p] = new float [_nS];
      _pforw3[t][p] = new float [_nS];
      _pforw4[t][p] = new float [_nS];
      _pback1[t][p] = new float [_nS];
      _pback2[t][p] = new float [_nS];

      _vitVval[t][p] = new float [_nS];
      _vitVbackM[t][p] = new int [_nS];
      _vitVbackS[t][p] = new int [_nS];
      _vitWval[t][p] = new float [_nS];
      _vitWbackR[t][p] = new int [_nS];
    }
  }

}

FbVar::~FbVar()
{
}
